=== debian/control ===
Source: oidc-agent
Section: misc
Priority: optional
Maintainer: Marcus Hardt <marcus@hardt-it.de>
Homepage: https://github.com/indigo-dc/oidc-agent/
Standards-Version: 4.6.0.1
Vcs-Git: https://salsa.debian.org/debian/oidc-agent.git
Vcs-Browser: https://salsa.debian.org/debian/oidc-agent
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               libcurl4-openssl-dev (>= 7.35.0),
               libsodium-dev (>= 1.0.14),
               help2man (>= 1.46.4),
               libseccomp-dev (>= 2.1.1),
               libmicrohttpd-dev (>= 0.9.33),
               check (>= 0.10.0),
               pkg-config (>= 0.29),
               libsecret-1-dev (>= 0.18.4),
               libcjson-dev (>= 1.7.10-1.1),
               libqrencode-dev (>= 3),

Package: oidc-agent-cli
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
                liboidc-agent4 (= ${binary:Version}),
                jq,
                libqrencode4 | libqrencode3,
Suggests: oidc-agent-desktop (= ${source:Version})
Replaces: oidc-agent (<< 4.1.0-1)
Description: Commandline tool for obtaining OpenID Connect Access tokens on the commandline
 oidc-agent is a set of tools to manage OpenID Connect tokens and make them
 easily usable from the command line. These tools follow ssh-agent design,
 so OIDC tokens can be handled in a similar way as ssh keys.  The agent
 stores multiple configurations and their associated refresh tokens
 securely.
 This tool consists of five programs:
   - oidc-agent that handles communication with the OIDC provider
   - oidc-gen that generates config files
   - oidc-add that loads (and unloads) configuration into the agent
   - oidc-token that can be used to get access token on the command line
   - oidc-keychain that re-uses oidc-agent across logins

Package: liboidc-agent4
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends},
Recommends: oidc-agent-cli (= ${binary:Version})
Description: oidc-agent library
 oidc-agent is a commandline tool for obtaining OpenID Connect Access tokens on
 the commandline.
 .
 This package provides a library for easy communication with oidc-agent.
 Applications can use this library to request access token from oidc-agent.

Package: liboidc-agent-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, liboidc-agent4 (= ${binary:Version})
Description: oidc-agent library development files
 oidc-agent is a commandline tool for obtaining OpenID Connect Access tokens on
 the commandline.
 .
 This package provides the development files (static library and headers)
 required for building applications with liboidc-agent, a library for
 communicating with oidc-agent.

Package: oidc-agent-desktop
Architecture: all
Depends: ${misc:Depends},
            oidc-agent-cli (>= ${source:Version}),
            xterm | x-terminal-emulator,
            yad
Replaces: oidc-agent (<< 4.1.0-1), oidc-agent-prompt (<< 4.1.0-1)
Description: oidc-agent desktop integration
 Desktop integration files for oidc-gen and oidc-agent and for creating the user
 dialog.
 .
 This package adds two ways for supporting the usage of oidc-agent in a
 graphical environment.
 The .desktop file to leverage browser integration to support the authorization
 code flow in oidc-gen.
 The Xsession file to consistently set the environment variables necessary to
 for client tools to connect to the oidc-agent daemon.
 .
 This package also provides a bash script as an interface to create different
 dialog windows. It uses yad to create windows.

Package: oidc-agent
Architecture: any
Depends: ${misc:Depends},
            oidc-agent-desktop (= ${source:Version})
Description: Commandline tools for obtaining OpenID Connect Access tokens
 oidc-agent is a set of tools to manage OpenID Connect tokens and make them
 easily usable from the command line.
 .
 This metapackage bundles the commandline tools and the files for desktop
 integration
