=== debian/rules ===
#!/usr/bin/make -f
# vi: ts=8 sw=8 noet

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all

# USE CJSON_SO / USE_LIST_SO:
# If set to 1 it will not use the shipped version, but the shared library
# installed via the corresponding lib[cjson|list]dev packages
export USE_CJSON_SO = 1
export USE_LIST_SO = 0

export BASEDIR 			= $(shell pwd)/debian/tmp
export BIN_AFTER_INST_PATH      = /usr
export BIN_PATH                 = $(BASEDIR)/usr
export MAN_PATH                 = $(BASEDIR)/usr/share/man
export CONFIG_PATH              = $(BASEDIR)/etc
export CONFIG_AFTER_INST_PATH   = /etc
export BASH_COMPLETION_PATH     = $(BASEDIR)/usr/share/bash-completion/completions
export DESKTOP_APPLICATION_PATH = $(BASEDIR)/usr/share/applications
export XSESSION_PATH            = $(BASEDIR)/etc/X11
export PROMPT_MAN_PATH          = $(BASEDIR)/usr/share/man
export PROMPT_BIN_PATH          = $(BASEDIR)/usr
#export AGENTSERVER_BIN_PATH     = $(BASEDIR)/usr
#export AGENTSERVER_MAN_PATH     = $(BASEDIR)/usr/share/man
export LIB_PATH                 = $(BASEDIR)/usr/lib/$(DEB_TARGET_MULTIARCH)
export LIBDEV_PATH              = $(BASEDIR)/usr/lib/$(DEB_TARGET_MULTIARCH)
export INCLUDE_PATH             = $(BASEDIR)/usr/include

%:
	dh $@ --no-parallel

# strange: without the override install_lib seems to happen, install_lib-dev not
override_dh_auto_install:
		make install install_lib install_lib-dev
