=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/oidc-agent-$1\.tar\.gz/ \
  https://github.com/indigo-dc/oidc-agent/tags .*/v?(\d\S+)\.tar\.gz
